"use strict";
/**
 * __template__gist__: https://gist.github.com/tomchentw/368a93bb748ad9d576f1#file-webpack-config-js
 */
var Path = require("path"),
		webpack = require("webpack"),
		HtmlWebpackPlugin = require("html-webpack-plugin"),
		webpackConfig,

		IS_PRODUCTION = "production" === process.env.NODE_ENV,
		JSX_WITH_HOT_LOEADERS = ["react-hot-loader", "jsx-loader?harmony"];

webpackConfig = module.exports = {
	entry: ["./index.js"],
	output: {
		path: Path.resolve(__dirname, "./public/"),
		publicPath: "public/",
		filename: (IS_PRODUCTION ? "[hash].js" : "app.js")
	},
	module: {
		loaders: [
			{ test: /\.js(x?)$/, exclude: /node_modules/, loaders: JSX_WITH_HOT_LOEADERS },
		]
	},
	plugins: [
		new HtmlWebpackPlugin({
			template: "./public/index.html",
			filename: "../index.html"
		})
	]
};

if (IS_PRODUCTION) {
	webpackConfig.plugins.push(
			new webpack.optimize.DedupePlugin()
	);
}